package de.hsbo.fbv.bmg.topology.networks;

/**
 * Edge - Interface fr Kanten.
 * @author Zimmermann, HS Bochum 2011
 *
 * @param <EdgeT>
 */
public interface Edge<EdgeT> extends Element<EdgeT> {

	/**
	 * Gibt den Start-Knoten zurck.
	 * @return
	 */
	public Node getStartNode();
	
	/**
	 * Gibt den End-Knoten zurck.
	 * @return
	 */
	public Node getEndNode();
	
	/**
	 * Gibt den jeweils anderen Knoten der Kante aus.
	 * @param node
	 * @return
	 */
	public Node getOppositeNode(Node node);
	
	/**
	 * Gibt die linke Masche zurck.
	 * @return
	 */
	public Face getLeftFace();
	
	/**
	 * Gibt die rechte Masche zurck.
	 * @return
	 */
	public Face getRightFace();
	
	/**
	 * Gibt die jeweils andere Masche der Kante aus.
	 * @param face
	 * @return
	 */
	public Face getOppositeFace(Face face);
	
	/**
	 * Dreht die Kantenrichtung um, bzw. vertauscht Anfangs- und Endknoten.
	 */
	public void turnRound();
	
}
