package de.hsbo.fbv.bmg.topology.networks;

/**
 * Element - Eltern-Interface fr Knoten und Kanten (Netzwerk-Elemente).
 * Das Bezugsobjekt (Knoten- oder Kantenobjekt) ist an das Element gebunden 
 * und nicht mehr vernderbar. Die anderen Attribute knnen sowohl gesetzt 
 * als auch abgefragt werden. 
 * @author Zimmermann, HS Bochum 2011
 *
 * @param <ElemT>
 */
public interface Element<ElemT> {
	
	/**
	 * Gibt das Element-Objekt zurck.
	 * @return
	 */
	public ElemT getObject();
	
	/**
	 * Gibt das Vorlufer-Element (fr die Auswertung von Netzwerk-Analysen) zurck.
	 * @return
	 */
	public Element getTrace();
	
	/**
	 * Gibt das Element-Gewicht zurck.
	 * @return
	 */
	public double getWeight();
	
	/**
	 * Gibt den Bearbeitungsstatus (fr Netzwerk-Analysen) zurck.
	 * @return
	 */
	public int getState();

	/**
	 * Setzt das Vorlufer-Element.
	 * @param elem
	 */
	public void setTrace(Element elem);
	
	/**
	 * Setzt das Element-Gewicht.
	 * @param weight
	 */
	public void setWeight(double weight);
	
	/**
	 * setzt den aktuellen Bearbeitungssatus.
	 * @param state
	 */
	public void setState(int state);

}
