package de.hsbo.fbv.bmg.topology.networks.impl;

import de.hsbo.fbv.bmg.topology.networks.Edge;
import de.hsbo.fbv.bmg.topology.networks.Face;
import de.hsbo.fbv.bmg.topology.networks.Node;

/**
 * 
 * @author zimmermann
 *
 * @param <EdgeT>
 */
public class SimpleEdge<EdgeT> extends SimpleElement<EdgeT> implements Edge<EdgeT> {
	
	// Attribute
	Node[] nodes = null;
	
	SimpleEdge(EdgeT object, Node start, Node end) {
		super(object);
		nodes = new Node[] {start, end};
	}
	
	@Override
	public Node getStartNode() {
		return nodes[0];
	}

	@Override
	public Node getEndNode() {
		return nodes[1];
	}

	@Override
	public void turnRound() {
		Node node = nodes[0];
		nodes[0] = nodes[1];
		nodes[1] = node;
	}

	@Override
	public Node getOppositeNode(Node node) {
		if(nodes[0]==node)
			return nodes[1];
		else if(nodes[1]==node)
			return nodes[0];
		else
			return null;
	}
	
	@Override
	public String toString() {
		return "Edge("+nodes[0].getObject()+","+nodes[1].getObject()+")"+
			"[" + super.toString() + "]";
	}

	@Override
	public Face getLeftFace() {
		try {
			throw new Exception("Method not implemented");
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	@Override
	public Face getRightFace() {
		try {
			throw new Exception("Method not implemented");
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	@Override
	public Face getOppositeFace(Face face) {
		try {
			throw new Exception("Method not implemented");
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

}
