package de.hsbo.fbv.bmg.topology.networks.impl;

import java.util.ArrayList;
import java.util.List;

import de.hsbo.fbv.bmg.topology.networks.Edge;
import de.hsbo.fbv.bmg.topology.networks.Node;



/**
 * 
 * @author zimmermann
 *
 * @param <NodeT>
 */
public class SimpleNode<NodeT> extends SimpleElement<NodeT> implements Node<NodeT> {
	
	// Attribute
	List<Edge> edges = null;

	SimpleNode(NodeT object) {
		super(object);
		edges = new ArrayList<Edge>();
	}

	@Override
	public Edge[] getEdges() {
		Edge[] result = new Edge[edges.size()];
		return edges.toArray(result);
	}

	@Override
	public Node[] getNextNodes() {
		Node[] result = new Node[edges.size()]; 
		for(int i=0; i<result.length; i++)
			result[i] = edges.get(i).getOppositeNode(this);
		return result;
	}

	boolean add(Edge edge) {
		if(edge.getStartNode()==this || edge.getEndNode()==this)
			return edges.add(edge);
		else 
			return false;
	}

	boolean remove(Object o) {
		return edges.remove(o);
	}

	boolean isIsolated() {
		if(edges.isEmpty())
			return true;
		else
			return false;
	}

	@Override
	public String toString() {
		return "Node[" + super.toString() + "]";
	}
	
	
	
}
